#ifndef CLIB_PLAYSID_PROTOS_H
#define CLIB_PLAYSID_PROTOS_H
/*
**	$Filename: clib/playsid_protos.h $
**	$Release: 1.0 $
**	$Revision: 1.0 $
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1994 Per Hkan Sundell and Ron Birk
**	All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

LONG AllocEmulResource( void );
void FreeEmulResource ( void );
LONG ReadIcon(char *filename, APTR header );
LONG CheckModule( APTR header );
void SetModule( APTR header, APTR fileLocation, UWORD fileLength );
LONG StartSong( UWORD tune );
void StopSong( void );
void PauseSong( void );
LONG ContinueSong( void );
void ForwardSong( UWORD speed );
void RewindSong( UWORD speed );
void SetVertFreq( UWORD frequency );
void SetChannelEnable( BOOL flags[4] );
void SetReverseEnable( BOOL flag );
/**/
/* The following private function are subject to change in future releases.*/
/* Please do not use them.*/
/**/
void SetTimeSignal( struct Task *task, ULONG timeMask );
void SetTimeEnable( BOOL flag );
void SetDisplaySignal( struct Task *task, ULONG displayMask );
void SetDisplayEnable( BOOL flag );

#endif /* CLIB_PLAYSID_PROTOS_H */
