<HTML>
<!-- created Oct 21 1995 from protracker.fmt line 130 via texi2www -->
<HEAD>
<TITLE>Decoding pattern information</TITLE>
<LINK REL="Precedes" HREF="Soundtracker_and_Protracker_tempo.html">
<LINK REV="Precedes" HREF="The_Protracker_file_format.html">
<LINK REV="Subdocument" HREF="The_Protracker_format.html">
</HEAD><BODY><P>
<A HREF="The_Protracker_file_format.html"><IMG ALIGN=MIDDLE SRC="../prev-arrow.gif" ALT="PREV"></A>
<A HREF="The_Protracker_format.html"> <IMG ALIGN=MIDDLE SRC="../up-arrow.gif" ALT="UP"></A>
<A HREF="Soundtracker_and_Protracker_tempo.html"><IMG ALIGN=MIDDLE SRC="../next-arrow.gif" ALT="NEXT"></A>
<CITE>Tracker 4.42</CITE></P>
<H2>8.2: Decoding pattern information</H2>
<P>
Each pattern holds 64 sets of 4 events, one for each Amiga track, numbered 
0 to 3 in the usual Amiga way (0-3: left channels, 1-2: right channels, see <A HREF="Amiga_audio_hardware.html">Amiga audio hardware</A>).
Some modules programmed on PC have a special signature <CODE>6CHN</CODE> or <CODE>8CHN</CODE>,
and accordingly, they feature more channels.
</P>
<P>
The four bytes per event are to be decoded as follows:
</P>
<DL><DT><DD>
<PRE>
    _____byte 1_____   byte2_    _____byte 3_____   byte4_
   |                | |      |  |                | |      |
   0000          0000-00000000  0000          0000-00000000

   Upper four    12 bits for    Lower four    Effect/parameters
   bits of sam-  note period.   bits of sam-
   ple number.                  ple number.
</PRE>
</DL>
<P>
Sample number should be in the range 0-31... anything else is an error, and
should be flagged as such. 
For standard protracker modules, the note period can be converted to a note n
with the following lookup table[1]:
</P>
<DL>
<DT><KBD>C-1 to B-1 </KBD>
<DD>
856,808,762,720,678,640,604,570,538,508,480,453
<DT><KBD>C-2 to B-2 </KBD>
<DD>
428,404,381,360,339,320,302,285,269,254,240,226
<DT><KBD>C-3 to B-3 </KBD>
<DD>
214,202,190,180,170,160,151,143,135,127,120,113
</DL>

<P>
Older tracker modules may use highly non-standard periods.
I have yet to encounter some, though. [2]
As a result tracker converts these pitch values to notes and stores notes 
internally.
These pitch values <EM>are</EM> Amiga-dependent. See <A HREF="Amiga_audio_hardware.html">Amiga audio hardware</A>, for further details.
</P>
<P>
The effect command has two parts:
an effect and parameters. You should actually decode it as three independent
nibbles: e (effect) phi (parameter, hi-part), plow (parameter, low-part).
The interpretation is very dependent of the actual command involved. In many
cases, phi and plow are read as a single byte parameter (para=phi&lt;&lt;4 | plow)
</P>
<P><HR>
<P>[1] Actually, tracker doesn't use this exact table, but builds a precise well-tempered scale using powers of 2, see `<CODE>notes.c</CODE>'</P>
<P>[2] It would be easy to add some heuristics to the virtual player to detect these modules, and build the corresponding well-tempered scale on the fly. The hardest decisions would be to adjust the table because of limited precision (values stored as integer arithmetic) and possible distinct scales for each sample.</P>
</BODY></HTML>
